<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# v1

```go
import "github.com/slok/sloth/pkg/kubernetes/api/sloth/v1"
```

## Index

- [Variables](<#variables>)
- [func Kind(kind string) schema.GroupKind](<#func-kind>)
- [func Resource(resource string) schema.GroupResource](<#func-resource>)
- [func VersionKind(kind string) schema.GroupVersionKind](<#func-versionkind>)
- [type Alert](<#type-alert>)
  - [func (in *Alert) DeepCopy() *Alert](<#func-alert-deepcopy>)
  - [func (in *Alert) DeepCopyInto(out *Alert)](<#func-alert-deepcopyinto>)
- [type Alerting](<#type-alerting>)
  - [func (in *Alerting) DeepCopy() *Alerting](<#func-alerting-deepcopy>)
  - [func (in *Alerting) DeepCopyInto(out *Alerting)](<#func-alerting-deepcopyinto>)
- [type PrometheusServiceLevel](<#type-prometheusservicelevel>)
  - [func (in *PrometheusServiceLevel) DeepCopy() *PrometheusServiceLevel](<#func-prometheusservicelevel-deepcopy>)
  - [func (in *PrometheusServiceLevel) DeepCopyInto(out *PrometheusServiceLevel)](<#func-prometheusservicelevel-deepcopyinto>)
  - [func (in *PrometheusServiceLevel) DeepCopyObject() runtime.Object](<#func-prometheusservicelevel-deepcopyobject>)
- [type PrometheusServiceLevelList](<#type-prometheusservicelevellist>)
  - [func (in *PrometheusServiceLevelList) DeepCopy() *PrometheusServiceLevelList](<#func-prometheusservicelevellist-deepcopy>)
  - [func (in *PrometheusServiceLevelList) DeepCopyInto(out *PrometheusServiceLevelList)](<#func-prometheusservicelevellist-deepcopyinto>)
  - [func (in *PrometheusServiceLevelList) DeepCopyObject() runtime.Object](<#func-prometheusservicelevellist-deepcopyobject>)
- [type PrometheusServiceLevelSpec](<#type-prometheusservicelevelspec>)
  - [func (in *PrometheusServiceLevelSpec) DeepCopy() *PrometheusServiceLevelSpec](<#func-prometheusservicelevelspec-deepcopy>)
  - [func (in *PrometheusServiceLevelSpec) DeepCopyInto(out *PrometheusServiceLevelSpec)](<#func-prometheusservicelevelspec-deepcopyinto>)
- [type SLI](<#type-sli>)
  - [func (in *SLI) DeepCopy() *SLI](<#func-sli-deepcopy>)
  - [func (in *SLI) DeepCopyInto(out *SLI)](<#func-sli-deepcopyinto>)
- [type SLIEvents](<#type-slievents>)
  - [func (in *SLIEvents) DeepCopy() *SLIEvents](<#func-slievents-deepcopy>)
  - [func (in *SLIEvents) DeepCopyInto(out *SLIEvents)](<#func-slievents-deepcopyinto>)
- [type SLIRaw](<#type-sliraw>)
  - [func (in *SLIRaw) DeepCopy() *SLIRaw](<#func-sliraw-deepcopy>)
  - [func (in *SLIRaw) DeepCopyInto(out *SLIRaw)](<#func-sliraw-deepcopyinto>)
- [type SLO](<#type-slo>)
  - [func (in *SLO) DeepCopy() *SLO](<#func-slo-deepcopy>)
  - [func (in *SLO) DeepCopyInto(out *SLO)](<#func-slo-deepcopyinto>)


## Variables

```go
var (
    // SchemeBuilder initializes a scheme builder.
    SchemeBuilder = runtime.NewSchemeBuilder(addKnownTypes)
    // AddToScheme is a global function that registers this API group & version to a scheme.
    AddToScheme = SchemeBuilder.AddToScheme
)
```

SchemeGroupVersion is group version used to register these objects\.

```go
var SchemeGroupVersion = schema.GroupVersion{Group: sloth.GroupName, Version: version}
```

## func Kind

```go
func Kind(kind string) schema.GroupKind
```

Kind takes an unqualified kind and returns back a Group qualified GroupKind\.

## func Resource

```go
func Resource(resource string) schema.GroupResource
```

Resource takes an unqualified resource and returns a Group qualified GroupResource\.

## func VersionKind

```go
func VersionKind(kind string) schema.GroupVersionKind
```

VersionKind takes an unqualified kind and returns back a Group qualified GroupVersionKind\.

## type Alert

Alert configures specific SLO alert\.

```go
type Alert struct {
    // Disable disables the alert and makes Sloth not generating this alert. This
    // can be helpful for example to disable ticket(warning) alerts.
    Disable bool `json:"disable,omitempty"`
    // Labels are the Prometheus labels for the specific alert. For example can be
    // useful to route the Page alert to specific Slack channel.
    Labels map[string]string `json:"labels,omitempty"`
    // Annotations are the Prometheus annotations for the specific alert.
    Annotations map[string]string `json:"annotations,omitempty"`
}
```

### func \(\*Alert\) DeepCopy

```go
func (in *Alert) DeepCopy() *Alert
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new Alert\.

### func \(\*Alert\) DeepCopyInto

```go
func (in *Alert) DeepCopyInto(out *Alert)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.

## type Alerting

Alerting wraps all the configuration required by the SLO alerts\.

```go
type Alerting struct {
    // Name is the name used by the alerts generated for this SLO.
    Name string `json:"name" validate:"required"`
    // Labels are the Prometheus labels that will have all the alerts generated by this SLO.
    Labels map[string]string `json:"labels,omitempty"`
    // Annotations are the Prometheus annotations that will have all the alerts generated by
    // this SLO.
    Annotations map[string]string `json:"annotations,omitempty"`
    // Page alert refers to the critical alert (check multiwindow-multiburn alerts).
    PageAlert Alert `json:"page_alert,omitempty"`
    // TicketAlert alert refers to the warning alert (check multiwindow-multiburn alerts).
    TicketAlert Alert `json:"ticket_alert,omitempty"`
}
```

### func \(\*Alerting\) DeepCopy

```go
func (in *Alerting) DeepCopy() *Alerting
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new Alerting\.

### func \(\*Alerting\) DeepCopyInto

```go
func (in *Alerting) DeepCopyInto(out *Alerting)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.

## type PrometheusServiceLevel

\+genclient \+k8s:deepcopy\-gen:interfaces=k8s\.io/apimachinery/pkg/runtime\.Object

PrometheusServiceLevel is the expected service quality level using Prometheus as the backend used by Sloth\.

```go
type PrometheusServiceLevel struct {
    metav1.TypeMeta `json:",inline"`
    // Standard object's metadata.
    // More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata
    // +optional
    metav1.ObjectMeta `json:"metadata,omitempty"`

    // Specification of the ddesired behaviour of the pod terminator.
    // More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status
    // +optional
    Spec PrometheusServiceLevelSpec `json:"spec,omitempty"`
}
```

### func \(\*PrometheusServiceLevel\) DeepCopy

```go
func (in *PrometheusServiceLevel) DeepCopy() *PrometheusServiceLevel
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new PrometheusServiceLevel\.

### func \(\*PrometheusServiceLevel\) DeepCopyInto

```go
func (in *PrometheusServiceLevel) DeepCopyInto(out *PrometheusServiceLevel)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.

### func \(\*PrometheusServiceLevel\) DeepCopyObject

```go
func (in *PrometheusServiceLevel) DeepCopyObject() runtime.Object
```

DeepCopyObject is an autogenerated deepcopy function\, copying the receiver\, creating a new runtime\.Object\.

## type PrometheusServiceLevelList

\+k8s:deepcopy\-gen:interfaces=k8s\.io/apimachinery/pkg/runtime\.Object

PrometheusServiceLevelList is a list of PrometheusServiceLevel resources\.

```go
type PrometheusServiceLevelList struct {
    metav1.TypeMeta `json:",inline"`
    metav1.ListMeta `json:"metadata"`

    Items []PrometheusServiceLevel `json:"items"`
}
```

### func \(\*PrometheusServiceLevelList\) DeepCopy

```go
func (in *PrometheusServiceLevelList) DeepCopy() *PrometheusServiceLevelList
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new PrometheusServiceLevelList\.

### func \(\*PrometheusServiceLevelList\) DeepCopyInto

```go
func (in *PrometheusServiceLevelList) DeepCopyInto(out *PrometheusServiceLevelList)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.

### func \(\*PrometheusServiceLevelList\) DeepCopyObject

```go
func (in *PrometheusServiceLevelList) DeepCopyObject() runtime.Object
```

DeepCopyObject is an autogenerated deepcopy function\, copying the receiver\, creating a new runtime\.Object\.

## type PrometheusServiceLevelSpec

ServiceLevelSpec is the spec for a PrometheusServiceLevel\.

```go
type PrometheusServiceLevelSpec struct {
    // Service is the application of the SLOs.
    Service string `json:"service"`
    // Labels are the Prometheus labels that will have all the recording
    // and alerting rules generated for the service SLOs.
    Labels map[string]string `json:"labels,omitempty"`
    // SLOs are the SLOs of the service.
    SLOs []SLO `json:"slos,omitempty"`
}
```

### func \(\*PrometheusServiceLevelSpec\) DeepCopy

```go
func (in *PrometheusServiceLevelSpec) DeepCopy() *PrometheusServiceLevelSpec
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new PrometheusServiceLevelSpec\.

### func \(\*PrometheusServiceLevelSpec\) DeepCopyInto

```go
func (in *PrometheusServiceLevelSpec) DeepCopyInto(out *PrometheusServiceLevelSpec)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.

## type SLI

SLI will tell what is good or bad for the SLO\. All SLIs will be get based on time windows\, that's why Sloth needs the queries to use \`\{\{\.window\}\}\` template variable\.

Only one of the SLI types can be used\.

```go
type SLI struct {
    // SLIRaw is the raw SLI type.
    Raw *SLIRaw `json:"raw,omitempty"`
    // SLIEvents is the events SLI type.
    Events *SLIEvents `json:"events,omitempty"`
}
```

### func \(\*SLI\) DeepCopy

```go
func (in *SLI) DeepCopy() *SLI
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new SLI\.

### func \(\*SLI\) DeepCopyInto

```go
func (in *SLI) DeepCopyInto(out *SLI)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.

## type SLIEvents

SLIEvents is an SLI that is calculated as the division of bad events and total events\, giving a ratio SLI\. Normally this is the most common ratio type\.

```go
type SLIEvents struct {
    // ErrorQuery is a Prometheus query that will get the number/count of events
    // that we consider that are bad for the SLO (e.g "http 5xx", "latency > 250ms"...).
    // Requires the usage of `{{.window}}` template variable.
    ErrorQuery string `json:"error_query"`
    // TotalQuery is a Prometheus query that will get the total number/count of events
    // for the SLO (e.g "all http requests"...).
    // Requires the usage of `{{.window}}` template variable.
    TotalQuery string `json:"total_query"`
}
```

### func \(\*SLIEvents\) DeepCopy

```go
func (in *SLIEvents) DeepCopy() *SLIEvents
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new SLIEvents\.

### func \(\*SLIEvents\) DeepCopyInto

```go
func (in *SLIEvents) DeepCopyInto(out *SLIEvents)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.

## type SLIRaw

SLIRaw is a error ratio SLI already calculated\. Normally this will be used when the SLI is already calculated by other recording rule\, system\.\.\.

```go
type SLIRaw struct {
    // ErrorRatioQuery is a Prometheus query that will get the raw error ratio (0-1) for the SLO.
    ErrorRatioQuery string `json:"error_ratio_query"`
}
```

### func \(\*SLIRaw\) DeepCopy

```go
func (in *SLIRaw) DeepCopy() *SLIRaw
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new SLIRaw\.

### func \(\*SLIRaw\) DeepCopyInto

```go
func (in *SLIRaw) DeepCopyInto(out *SLIRaw)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.

## type SLO

SLO is the configuration/declaration of the service level objective of a service\.

```go
type SLO struct {
    // Name is the name of the SLO.
    Name string `json:"name"`
    // Objective is target of the SLO the percentage (0, 100] (e.g 99.9).
    Objective json.Number `json:"objective"`
    // Labels are the Prometheus labels that will have all the recording and
    // alerting rules for this specific SLO. These labels are merged with the
    // previous level labels.
    Labels map[string]string `json:"labels,omitempty"`
    // SLI is the indicator (service level indicator) for this specific SLO.
    SLI SLI `json:"sli"`
    // Alerting is the configuration with all the things related with the SLO
    // alerts.
    Alerting Alerting `json:"alerting"`
}
```

### func \(\*SLO\) DeepCopy

```go
func (in *SLO) DeepCopy() *SLO
```

DeepCopy is an autogenerated deepcopy function\, copying the receiver\, creating a new SLO\.

### func \(\*SLO\) DeepCopyInto

```go
func (in *SLO) DeepCopyInto(out *SLO)
```

DeepCopyInto is an autogenerated deepcopy function\, copying the receiver\, writing into out\. in must be non\-nil\.



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
